include "Vram.inc"
include "VVram.inc"
include "Chars.inc"

ext VVram_
ext BaseX_, BaseY_, Map_

MapStep equ 8

; ptr<byte> VVramPtr(byte x, byte y);
cseg
VVramPtr_: public VVramPtr_
    push psw | push d| push b
        mov c,a
        mvi b,0

        mvi h,0
        mov l,e
        dad h ;*2
        dad h ;*4
        dad h ;*8
        dad h ;*16
        dad b
        lxi b,VVram_
        dad b
    pop b | pop d | pop psw
ret


; void MapToVVram();
cseg
MapToVVram_: public MapToVVram_
    push psw | push h | push d | push b
        lda BaseY_
        mov l,a
        mvi h,0
        dad h ;*2
        dad h ;*4
        dad h ;*8 : map.step
        lxi d,Map_
        dad d
        lda BaseX_
        mov b,a
        ora a|rar
        ora a|rar
        ora a|rar
        mov e,a
        mvi d,0
        dad d
        xchg
        mov a,b
        ani $07
        mov b,a
        mvi a,1
        do | while nz
            ora a|ral
            dcr b
        wend
        mov c,a
        lxi h,VVram_
        mvi b,VVramHeight
        do
            push b
                push d
                    mvi b,VVramWidth
                    do
                        ldax d
                        ana c
                        if nz
                            mvi m,Char_Wall
                        else
                            mvi m,Char_Space
                        endif
                        inx h
                        mov a,c
                        ora a|rlc
                        mov c,a
                        if c
                            inx d
                        endif
                        dcr b
                    while nz | wend
                pop d
                xchg
                    lxi b,MapStep
                    dad b
                xchg
                ; lxi b,VramRowSize-VVramHeight
                ; dad b
            pop b
            dcr b
        while nz | wend
    pop b | pop d | pop h | pop psw
ret